
%union {
char *exp_string;
}

%token <exp_string> INT CHAR SHORT
%token <exp_string> ESTRING FOR CLRSCR PUTCH GETCH SETFONT PROC DEC_CONST DBL_EQUALS IF
%token <exp_string> RANDOM PXL_ON PXL_OFF PXL_CHG KBHIT RETURN ELSE WHILE TRUE FALSE DELAY
%token <exp_string> LITERAL_CHAR MALLOC FREE STRING PUTS
%token <exp_string> INLINE_ASSEMBLY STRING_CONSTANT SETPROGNAME

/* tokens are terminals */
%type  <exp_string>  exp statmnt opt_expr defn statmnts block procs procedure procname
%type  <exp_string>  RVal LVal binop_exp
%type  <exp_string>  assembly_lines
/* types are non-terminals */

%left  <exp_string>  LOGICAL_XOR
%left  <exp_string>  LOGICAL_OR
%left  <exp_string>  LOGICAL_AND
%left  <exp_string>  BITWISE_OR
%left  <exp_string>  BITWISE_XOR
%left  <exp_string>  BITWISE_AND
%left  <exp_string>  EQUAL_TO NOT_EQUAL_TO
%left  <exp_string>  LESS_THAN GREATER_THAN GREATER_THAN_OR_EQUAL_TO LESS_THAN_OR_EQUAL_TO
%left  <exp_string>  BITWISE_SHIFT_LEFT BITWISE_SHIFT_RIGHT
%left  <exp_string>  ADD SUBTRACT
%left  <exp_string>  MULTIPLY DIVIDE MODULO

%% /* Grammar rules and actions follow */


input:                /* empty */
	| input program
	;


program:    defn procs      {
					printf(";******Variables:******\n\n\n");
					if( NoMallocHandler )
					{
					printf("   mallocerr:\n"
						"    move.l  stack_pointer,a7\n"
						"    move.l  0,-(a7)\n"
						"    jsr     romlib[set_font]\n"
						"    lea     2(a7),a7\n"
						"    move.w  #1,-(a7)\n"
						"    pea     malloc_mesg1(PC)\n"
						"    move.w  #10,-(a7)\n"
						"    move.w  #10,-(a7)\n"
						"    jsr     romlib[puttext]\n"
						"    lea     10(a7),a7\n"
						"    move.w  #1,-(a7)\n"
						"    pea     malloc_mesg2(PC)\n"
						"    move.w  #25,-(a7)\n"
						"    move.w  #15,-(a7)\n"
						"    jsr     romlib[puttext]\n"
						"    lea     10(a7),a7\n"
						"    jsr     flib[idle_loop]\n"
						"    move.l  stack_pointer,a7\n"
						"    rts\n"
						"\n");
					}

					printf("   div0_handler:\n"
					"    move.l  stack_pointer,a7\n"
					"    move.w  0,-(a7)\n"
					"    jsr     romlib[set_font]\n"
					"    lea     2(a7),a7\n"
					"    move.w  #1,-(a7)\n"
					"    pea     div0_mesg1(PC)\n"
					"    move.w  #10,-(a7)\n"
					"    move.w  #10,-(a7)\n"
					"    jsr     romlib[puttext]\n"
					"    lea     10(a7),a7\n"
					"    move.w  #1,-(a7)\n"
					"    pea     div0_mesg2(PC)\n"
					"    move.w  #25,-(a7)\n"
					"    move.w  #15,-(a7)\n"
					"    jsr     romlib[puttext]\n"
					"    lea     10(a7),a7\n"
					"    jsr     flib[idle_loop]\n"
					"    move.l    stack_pointer,a7\n"
					"    rts\n");

								if (ProgNameSet==0)
										printf("   prog_name:  dc.b 160,\"Made by TICC v0.6\",129,0\n\n");
                                printf(
					" div0_mesg1: dc.b 7,\"ERROR: Divide by zero. \",7,0\n"
					" div0_mesg2: dc.b \"Press any key to terminate program...\",0\n"
					" malloc_mesg1: dc.b 7,\"ERROR: No memory available for malloc.\",7,0\n"
					" malloc_mesg2: dc.b \"Press any key to terminate program...\",0\n"
					"  tempstore0: dc.l 0\n"
					"  tempstore1: dc.l 0\n"
					"  tempstore2: dc.l 0\n"
					"  tempstore3: dc.l 0\n"
					"  stack_pointer: dc.l 0\n"
					"%s\n"
					"   reloc_open\n"
					"   add_library     flib\n"
					"   add_library     romlib\n"
					"   reloc_close\n"
					"   end\n", $1);
				}
	;


defn:   INT ESTRING ';'
				{
				char *Out;
				Out=malloc(strlen($2)+100);
				sprintf(Out,"  %s: dc.l 0\n",$2);
				$$=Out;
				free($2);
				}
        | STRING ESTRING '=' STRING_CONSTANT ';'
                                {
				char *Out;
                                char *Str;
                                switch((strlen($4)-1)%4)
                                        {
                                        case 1:       Str=",0,0,0";break;
                                        case 2:       Str=",0,0";break;
                                        case 3:       Str=",0";break;
                                        default:        Str="";break;
                                        }
                                if (strcmp($2,"prog_name")==0) ProgNameSet=1;
				Out=malloc(strlen($2)+100+strlen($4));
				sprintf(Out,"  %s: dc.b %s,0%s\n",$2,$4,Str);
				$$=Out;
				free($2);
                                free($4);
                                }
	| INT ESTRING '=' DEC_CONST ';'
				{
				char *Out;
				Out=malloc(strlen($4)+strlen($2)+100);
				sprintf(Out,"  %s: dc.l %s\n",$2,$4);
				$$=Out;
				free($2);
				free($4);
				}



	| defn defn             {
				char *Out;
				Out=malloc(10);
				sprintf(Out," ");
				printf("%s%s",$1,$2);
				$$=Out;
				free($1);free($2);
				}

	;

procs:                          {}
	| procedure procs       {}
	;

procname:   ESTRING     {$$=$1;};

procedure:
	PROC procname '(' parameter_list ')' statmnt procname ';'
				{
				FILE *FileHandle;
				char FileName[100];
				sprintf(FileName, "_%s.%d",$2,IncludeCount);
				printf("   include \"%s\"\n",FileName);
				FileHandle=fopen(FileName,"wb");
								fprintf(FileHandle,
					"\n"
					";***************************************\n"
					";* Procedure %s\n"
					";***************************************\n"
					"   %s:\n"
					"    move.l    a6,-(a7)\n"
					"    move.l    a7,a6\n"
					"%s"
					"    move.l    a6,a7\n"
					"    move.l    (a7)+,a6\n"
					"    move.l    #0,d0\n"
					"    rts       ;return from proc %s\n",$2,$2,$6,$2);
								fclose(FileHandle);
								IncludeCount++;
				fprintf(stderr,"Procedure '%s' saved as '%s', %d bytes.\n",$2,FileName,strlen($6));
				if( strcmp($2,"mallocerr")==0 ) NoMallocHandler=0;

				free($2);
				free($6);
								free($7);
				}
	;

parameter_list:                 {
//              fprintf(stderr,"");
				}
	| defn parameter_list   {}
	;


opt_expr:               {$$=CopyString("    move.l		#1,d0\n");}
	|   exp         {$$=CopyString($1);free($1);}
	;

LVal:   ESTRING         {
				char *Out;
				Out=malloc(strlen($1)+100);
				sprintf(Out,
					"    lea.l  %s(PC),a3    ;push LVal address onto the stack\n"
					"    move.l	a3,d0\n",$1);
				$$=Out;
								free($1);
				}
	| LVal '[' exp ']'
				{
				char *Out=malloc(strlen($1)+strlen($3)+500);
				sprintf(Out,
					"%s"
					"   move.l     d0,a0\n"
					"   move.l     (a0),d0\n"
					"   handle_ptr d0,a0\n"
					"   move.l     a0,-(a7)\n"
					"%s"
					"   lsl        #2,d0\n"
					"   add.l      (a7)+,d0\n",$1,$3);
				$$=Out;
				free($3);
				}

	;

RVal:       DEC_CONST   {
				char *Out=malloc(strlen($1)+100);
				sprintf(Out,
					"    move.l    #%s,d0        ;constant value: %s\n",$1,$1);
				$$=Out;
								free($1);
				}
        |   assembly_lines      {$$=$1;}

	|   LITERAL_CHAR        {
				char *Out=malloc(strlen($1)+100);
				sprintf(Out,
					"    move.l    #%d,d0        ;literal char '%c'\n",$1[1],$1[1]);
				$$=Out;
				}

	|   TRUE        {
				$$=CopyString("    move.l    #1,d0        ;push TRUE\n");
				}

	|   FALSE       {
				$$=CopyString("    move.l    #0,d0        ;push FALSE\n");
				}

	|   ESTRING     {
//              if (SymbolTable.FindSymbol($1)==NULL)
//                  {
//                  printf("Symbol '%s' not found in symbol table (please declare it)\n",$1);
//                  exit(1);
//                  }

				char *Out=malloc(strlen($1)+100);
				sprintf(Out,"    move.l    %s,d0        ;variable value: %s\n",$1,$1);
				$$=Out;
				free($1);
				}
	| LVal '[' exp ']'
				{
				char *Out=malloc(strlen($1)+strlen($3)+500);
				sprintf(Out,
					"%s"
					"   move.l     d0,a0\n"
					"   move.l     (a0),d0\n"
					"   handle_ptr d0,a0\n"
					"   move.l     a0,-(a7)\n"
					"%s"
					"   lsl        #2,d0\n"
					"   add.l      (a7)+,d0\n"
					"   move.l     d0,a0\n"
					"   move.l     (a0),d0\n",$1,$3);
				$$=Out;
				free($3);
				}




	|   GETCH '(' ')'   {               //clear screen
				char *Out;
				Out=malloc(300);
				sprintf(Out,"    jsr    flib[idle_loop]\n");
				$$=Out;
				}
	|   SETFONT '(' exp ')'
				{               //clear screen
				char *Out;
				Out=malloc(300+strlen($3));
				sprintf(Out,
					"%s"
					"    move.w    d0,-(a7)\n"
					"    jsr    romlib[set_font]\n"
					"    lea    2(a7),a7\n",$3);
				$$=Out;
				free($3);
				}

	|   MALLOC '(' exp ')'  {
				char *Out;
				Out=malloc(500+strlen($3));
				sprintf(Out,
					"%s"
					"   move.l   d0,-(a7)\n"
					"   jsr      romlib[create_handle]\n"
					"   lea      4(a7),a7\n"
					"   cmp.l    #0,d0           ;test for div0;\n"
					"   bne      malloc_test_label_%d\n"
					"   bsr      mallocerr\n"
					"  malloc_test_label_%d:\n",$3,Labeler,Labeler);
				Labeler++;
				$$=Out;
				}

	|   FREE '(' exp ')'   {
				char *Out;
				Out=malloc(500+strlen($3));
				sprintf(Out,
					"%s"
					"   move.w   d0,-(a7)\n"
					"   jsr      romlib[destroy_handle]\n"
					"   addq     #2,a7\n",$3);
				$$=Out;
				}

	|   DELAY '(' exp ')'
				{
				char *Out;
				Out=malloc(300+strlen($3));
				sprintf(Out,
					"%s"
					"   delay_label_%d:\n"
					"    sub.l     #1,d0\n"
					"    cmp.l     #0,d0\n"
					"    bne       delay_label_%d\n",$3,Labeler,Labeler);
				Labeler++;
				$$=Out;
				free($3);
				}

	|   CLRSCR '(' ')'  {
				char *Out;
				Out=malloc(300);
				sprintf(Out,
					"    jsr    flib[clr_scr]\n");
				$$=Out;
				}

	|   RANDOM '(' exp ')'
				{
				char *Out;
				Out=malloc(strlen($3)+1000);
				sprintf(Out,"%s"
					"    jsr    flib[random]\n",$3);
				$$=Out;
				free($3);
				}


	|   KBHIT '(' ')'   {               //returns key pressed or zero
				char *Out;
				Out=malloc(1000);
				sprintf(Out,
					"    move.l #0,d0\n"
					"    move.w ($75B0),d0\n");
				$$=Out;
				}

	|   PXL_ON '(' exp ',' exp ')'    { //turns specified pixel on
				char *Out;

				Out=malloc(1000+strlen($3)+strlen($5));
				sprintf(Out,
					"%s"
					"    move.l	d0,-(a7)\n"
					"%s"
					"    move.l (a7)+,d1\n"
					"    move.w d0,-(a7)\n"
					"    move.w d1,-(a7)\n"
					"    jsr    flib[pixel_on]\n"
					"    lea    4(a7),a7\n",$3,$5);
				$$=Out;
				free($3);free($5);
				}

	|   PXL_OFF '(' exp ',' exp ')'    { //turns specified pixel on
				char *Out;
				Out=malloc(1000+strlen($3)+strlen($5));
				sprintf(Out,
					"%s"
					"    move.l	d0,-(a7)\n"
					"%s"
					"    move.l (a7)+,d1\n"
					"    move.w d0,-(a7)\n"
					"    move.w d1,-(a7)\n"
					"    jsr    flib[pixel_off]\n"
					"    lea    4(a7),a7\n",$3,$5);
				$$=Out;
				free($3);free($5);
				}

	|   PXL_CHG '(' exp ',' exp ')'    { //turns specified pixel on
				char *Out;

				Out=malloc(1000+strlen($3)+strlen($5));
				sprintf(Out,
					"%s"
					"    move.l	d0,-(a7)\n"
					"%s"
					"    move.l (a7)+,d1\n"
					"    move.w d0,-(a7)\n"
					"    move.w d1,-(a7)\n"
					"    jsr    flib[pixel_chg]\n"
					"    lea    4(a7),a7\n",$3,$5);
				free($3);free($5);
				$$=Out;
				}

        |   PUTS '(' exp ',' exp ',' ESTRING ',' exp ')'
                                {
				char *Out;
				Out=malloc(strlen($3)+strlen($5)+strlen($7)+strlen($9)+3000);
				sprintf(Out,
                                        "%s"
                                        "    move.w     d0,-(a7)\n"
                                        "    pea        %s(PC)\n"
					"%s"
					"    move.w	d0,-(a7)\n"
					"%s"
					"    move.w	d0,-(a7)\n"
					"    jsr     romlib[puttext]\n"
					"    lea     10(a7),a7\n",$9,$7,$5,$3);
				$$=Out;
				free($3);
				free($5);
				free($7);
				free($9);
                                }

	|   PUTCH '(' exp ',' exp ',' exp ')'
				{               //putchar
				char *Out;
				Out=malloc(strlen($3)+strlen($5)+strlen($7)+3000);
				sprintf(Out,
					"%s"
					"    move.l	d0,-(a7)\n"
					"%s"
					"    move.l	d0,-(a7)\n"
					"%s"
					"    move.l    (a7)+,d1\n"
					"    move.l    (a7)+,d2\n"
					"    move.w    #$00FF,-(a7)\n"
					"    move.w    #$0000,-(a7)\n"
					"    move.w    #$00FF,-(a7)\n"
					"    move.w    #1,-(a7)\n"
					"    move.w    d1,-(a7)\n"
					"    move.w    d0,-(a7)\n"
					"    move.w    d2,-(a7)\n"
					"    jsr    romlib[putchar]\n"
					"    lea    14(a7),a7\n",$7,$5,$3);
				$$=Out;
				free($3);
				free($5);
				free($7);
				}



	|   ESTRING '(' ')' {       //Generic Function Call
				char *Out=malloc(strlen($1)+100);
				sprintf(Out,
					"    bsr       %s        ;Function call\n",
					$1);
				$$=Out;
								free($1);
				}

	|   binop_exp       {
				$$=CopyString($1);free($1);
				}

	|   '(' RVal ')'        {$$=$2;}
	;

binop_exp:
	RVal LOGICAL_OR RVal    {
				char *Out=malloc(400+strlen($1)+strlen($3));
				sprintf(Out,
					"%s"
					"    move.l	d0,-(a7)\n"
					"%s"
					"    move.l    (a7)+,d1    ;Binopp\n"
					"    cmp.l	#0,d0		;cmp\n"
					"    beq	l_or_1_%d\n"
					"    move.l	#1,d0\n"
										"    bra        l_or_3_%d\n"
					"   l_or_1_%d:\n"
					"    cmp.l	#0,d1\n"
					"    beq        l_or_2_%d\n"
					"    move.l     #1,d0\n"
										"    bra        l_or_3_%d\n"
					"   l_or_2_%d:\n"
					"    move.l	#0,d0\n"
					"   l_or_3_%d:\n",
					$3,$1,
					Labeler,Labeler,Labeler,Labeler,Labeler,Labeler,Labeler);
				Labeler++;
								$$=Out;
				}
	| RVal LOGICAL_AND RVal {
				char *Out=malloc(400+strlen($1)+strlen($3));
				sprintf(Out,
					"%s"
					"    move.l	d0,-(a7)\n"
					"%s"
					"    move.l    (a7)+,d1    ;Binopp\n"
					"    cmp.l	#0,d0		;cmp\n"
					"    beq		l_or_1_%d\n"
					"    move.l	#1,d0\n"
					"   l_or_1_%d:\n"
					"    cmp.l	#0,d1\n"
					"    beq		l_or_2_%d\n"
					"    move.l     #1,d1\n"
					"   l_or_2_%d:\n"
					"    and.l	d1,d0\n",
					$3,$1,
					Labeler,Labeler,Labeler,Labeler);
				Labeler++;
				$$=Out;
				}
	| RVal LOGICAL_XOR RVal {
				char *Out=malloc(400+strlen($1)+strlen($3));
					sprintf(Out,
					"%s"
					"    move.l	d0,-(a7)\n"
					"%s"
					"    move.l    (a7)+,d1    ;Binopp\n"
					"    cmp.l	#0,d0		;cmp\n"
					"    beq		l_eor_1_%d\n"
					"    move.l	#1,d0\n"
					"   l_eor_1_%d:\n"
					"    cmp.l	#0,d1\n"
					"    beq		l_eor_2_%d\n"
					"    move.l     #1,d1\n"
					"   l_eor_2_%d:\n"
					"    eor.l	d1,d0\n",
					$3,$1,
					Labeler,Labeler,Labeler,Labeler);
				Labeler++;
				$$=Out;
				}
	| RVal EQUAL_TO RVal    {
				char *Out=malloc(400+strlen($1)+strlen($3));
					sprintf(Out,
					"%s"
					"    move.l	d0,-(a7)\n"
					"%s"
					"    move.l    (a7)+,d1    ;Binopp\n"
					"    cmp.l	d1,d0		;cmp\n"
					"    beq	equals_binop_true_label_%d\n"
					"    move.l	#0,d0		;was true, set to 1\n"
					"    bra	equals_binop_done_label_%d\n"
					"   equals_binop_true_label_%d:\n"
					"    move.l	#1,d0		;default 0\n"
					"   equals_binop_done_label_%d:\n",
					$3,$1,
					Labeler,Labeler,Labeler,Labeler);
				Labeler++;
				$$=Out;
				}
	| RVal GREATER_THAN_OR_EQUAL_TO RVal    {
				char *Out=malloc(400+strlen($1)+strlen($3));
					sprintf(Out,
					"%s"
					"    move.l	d0,-(a7)\n"
					"%s"
					"    move.l    (a7)+,d1    ;Binopp\n"
					"    cmp.l      d1,d0		;cmp\n"
					"    bge	gtoequalto_true_label_%d\n"
					"    move.l     #0,d0		;was true, set to 1\n"
					"    bra	gtoequalto_done_label_%d\n"
					"   gtoequalto_true_label_%d:\n"
					"    move.l     #1,d0		;default 0\n"
					"   gtoequalto_done_label_%d:	\n",
					$3,$1,
					Labeler,Labeler,Labeler,Labeler);
				Labeler++;
				$$=Out;
				}
	| RVal LESS_THAN_OR_EQUAL_TO RVal   {
				char *Out=malloc(400+strlen($1)+strlen($3));
					sprintf(Out,
					"%s"
					"    move.l	d0,-(a7)\n"
					"%s"
					"    move.l    (a7)+,d1    ;Binopp\n"
					"    cmp.l      d1,d0		;cmp\n"
					"    ble	ltoequalto_true_label_%d\n"
					"    move.l     #0,d0		;was true, set to 1\n"
					"    bra	ltoequalto_done_label_%d\n"
					"   ltoequalto_true_label_%d:\n"
					"    move.l     #1,d0		;default 0\n"
					"   ltoequalto_done_label_%d:	\n",
					$3,$1,
					Labeler,Labeler,Labeler,Labeler);
				Labeler++;
				$$=Out;
				}
	| RVal NOT_EQUAL_TO RVal    {
				char *Out=malloc(400+strlen($1)+strlen($3));
					sprintf(Out,
					"%s"
					"    move.l	d0,-(a7)\n"
					"%s"
					"    move.l    (a7)+,d1    ;Binopp\n"
					"    cmp.l      d1,d0		;cmp\n"
					"    bne	notequal_true_label_%d\n"
					"    move.l     #0,d0		;was true, set to 1\n"
					"    bra	notequal_done_label_%d\n"
					"   notequal_true_label_%d:\n"
					"    move.l     #1,d0		;default 0\n"
					"   notequal_done_label_%d:	\n",
					$3,$1,
					Labeler,Labeler,Labeler,Labeler);
				Labeler++;
				$$=Out;
				}
	| RVal GREATER_THAN RVal        {
				char *Out=malloc(400+strlen($1)+strlen($3));
					sprintf(Out,
					"%s"
					"    move.l	d0,-(a7)\n"
					"%s"
					"    move.l    (a7)+,d1    ;Binopp\n"   
					"    cmp.l      d1,d0		;cmp\n"
					"    bgt	gt_true_label_%d\n"
					"    move.l     #0,d0		;was true, set to 1\n"
					"    bra	gt_done_label_%d\n"
					"   gt_true_label_%d:\n"
					"    move.l     #1,d0		;default 0\n"
					"   gt_done_label_%d:	\n",
					$3,$1,
					Labeler,Labeler,Labeler,Labeler);
				Labeler++;
				$$=Out;
				}
	| RVal LESS_THAN RVal   {
				char *Out=malloc(400+strlen($1)+strlen($3));
					sprintf(Out,
					"%s"
					"    move.l	d0,-(a7)\n"
					"%s"
										"    move.l     (a7)+,d1\n"
					"    cmp.l      d1,d0		;cmp\n"
					"    blt	lt_true_label_%d\n"
					"    move.l     #0,d0		;was true, set to 1\n"
					"    bra	lt_done_label_%d\n"
					"   lt_true_label_%d:\n"
					"    move.l     #1,d0		;default 0\n"
					"   lt_done_label_%d:	\n",
					$3,$1,
					Labeler,Labeler,Labeler,Labeler);
				Labeler++;
				$$=Out;
				}
	| RVal DIVIDE RVal      {
				char *Out=malloc(400+strlen($1)+strlen($3));
					sprintf(Out,
					"%s"
					"    move.l	d0,-(a7)\n"
					"%s"
					"    move.l    (a7)+,d1    ;Binopp\n"
					"    cmp.l	#0,d1		;test for div0;\n"
					"    bne	machine_label_%d\n"
					"    bra	div0_handler\n"
					"   machine_label_%d:\n"
					"    divs.l	d1,d0		;division\n"
					"    and.l	#$FFFF,d0		;delete the MOD field (in the upper bits)\n",
					$3,$1,
					Labeler,Labeler);
				Labeler++;
				$$=Out;
				}
	| RVal MODULO RVal      {
				char *Out=malloc(400+strlen($1)+strlen($3));
					sprintf(Out,
					"%s"
					"    move.l	d0,-(a7)\n"
					"%s"
					"    move.l    (a7)+,d1    ;Binopp\n"
					"    cmp.l	#0,d1		;test for div0;\n"
					"    bne	machine_label_%d\n"
					"    bra	div0_handler\n"
					"   machine_label_%d:\n"
					"    divs.l	d1,d0		;division\n"
					"    lsr.l	#8,d0\n"
					"    lsr.l	#8,d0		;move the REM field into the lower bits\n",
					$3,$1,
					Labeler,Labeler);
				Labeler++;
				$$=Out;
				}
	| RVal ADD RVal     {
				char *Out=malloc(400+strlen($1)+strlen($3));
					sprintf(Out,
					"%s"
					"    move.l	d0,-(a7)\n"
					"%s"
					"    move.l    (a7)+,d1    ;Binopp\n"
					"    add.l	d1,d0		;add\n",
					$3,$1 );
				Labeler++;
				$$=Out;
				}
	| RVal SUBTRACT RVal        {
				char *Out=malloc(400+strlen($1)+strlen($3));
					sprintf(Out,
					"%s"
					"    move.l	d0,-(a7)\n"
					"%s"
					"    move.l    (a7)+,d1    ;Binopp\n"
					"    sub.l	d1,d0		;sub\n",
					$3,$1 );
				Labeler++;
				$$=Out;
				}
	| RVal MULTIPLY RVal        {
				char *Out=malloc(400+strlen($1)+strlen($3));
					sprintf(Out,
					"%s"
					"    move.l	d0,-(a7)\n"
					"%s"
					"    move.l    (a7)+,d1    ;Binopp\n"
					"    muls.l	d1,d0		;muliply\n",
					$3,$1 );
				Labeler++;
				$$=Out;
				}
	| RVal BITWISE_AND RVal     {
				char *Out=malloc(400+strlen($1)+strlen($3));
					sprintf(Out,
					"%s"
					"    move.l	d0,-(a7)\n"
					"%s"
					"    move.l    (a7)+,d1    ;Binopp\n"
					"    and.l	d1,d0		;bitwise and\n",
					$3,$1 );
				Labeler++;
				$$=Out;
				}
	| RVal BITWISE_OR RVal      {
				char *Out=malloc(400+strlen($1)+strlen($3));
					sprintf(Out,
					"%s"
					"    move.l	d0,-(a7)\n"
					"%s"
					"    move.l    (a7)+,d1    ;Binopp\n"
					"    or.l	d1,d0		;bitwise or\n",
					$3,$1 );
				Labeler++;
				$$=Out;
				}
	| RVal BITWISE_XOR RVal     {
				char *Out=malloc(400+strlen($1)+strlen($3));
					sprintf(Out,
					"%s"
					"    move.l	d0,-(a7)\n"
					"%s"
					"    move.l    (a7)+,d1    ;Binopp\n"
					"    eor.l	d1,d0		;bitwise xor\n",
					$3,$1 );
				Labeler++;
				$$=Out;
				}
	| RVal BITWISE_SHIFT_LEFT RVal      {
				char *Out=malloc(400+strlen($1)+strlen($3));
					sprintf(Out,
					"%s"
					"    move.l	d0,-(a7)\n"
					"%s"
					"    move.l    (a7)+,d1    ;Binopp\n"
					"    lsl.l	d1,d0\n",
					$3,$1 );
				Labeler++;
				$$=Out;
				}
	| RVal BITWISE_SHIFT_RIGHT RVal     {
				char *Out=malloc(400+strlen($1)+strlen($3));
					sprintf(Out,
					"%s"
					"    move.l	d0,-(a7)\n"
					"%s"
					"    move.l    (a7)+,d1    ;Binopp\n"
					"    lsr.l	d1,d0\n",
					$3,$1 );
				Labeler++;
				$$=Out;
				}
	;
exp:        RVal        {$$=$1;}
	|   LVal '=' exp        {
				char *Out=malloc(strlen($3)+strlen($1)+400);
				sprintf(Out,
					"%s"
					"    move.l	d0,-(a7)\n"
					"%s"
					"    move.l    (a7)+,a3    ;pop LVal memory address\n"
					"    move.l    d0,(a3)        ;store expression result at LVal memory address\n",
					$1,$3);
				$$=Out;
				free($1);free($3);
				}
	;

statmnts:                       {$$=CopyString("");}
	| statmnt statmnts
				{
				char *Out=malloc(strlen($1)+strlen($2)+100);
				sprintf(Out,"%s%s",$1,$2);
				$$=Out;
				free($1);
				free($2);
				};

assembly_lines: INLINE_ASSEMBLY {
                                char *Out=malloc(strlen($1)+100);
                                sprintf(Out,"%s\n",$1+1);       //the "+1" strips the "~" from the string
                                free($1);
                                $$=Out;
                                }
        | INLINE_ASSEMBLY assembly_lines {
                                char *Out=malloc(strlen($1)+strlen($2)+100);
                                sprintf(Out,"%s\n%s",$1+1,$2);       //the "+1" strips the "~" from the string
                                free($1);
                                free($2);
                                $$=Out;
                                }
        ;


block:      '{' statmnts '}'    {$$=$2;}
	;

statmnt:    ';'         {$$=CopyString("");}
	| RETURN ';'
				{
				char * Out=malloc(300);
				sprintf(Out,    "    move.l    #0,d0\n"
						"    move.l    a6,a7\n"
						"    move.l    (a7)+,a6\n"
						"    rts\n");
				$$=Out;
				}
	| RETURN exp ';'        {
				char * Out=malloc(300);
				sprintf(Out,    "%s"
						"    move.l    a6,a7\n"
						"    move.l    (a7)+,a6\n"
						"    rts\n",$2);
				$$=Out;
				free($2);
				}
	| exp ';'       {$$=$1;}

	| IF '(' exp ')' statmnt
				{
				char *Out;
				Out=malloc(strlen($3)+strlen($5)+1000);
				sprintf(Out,
					"%s"
					"    cmp.l    #0,d0    ;if statment\n"
					"    beq        if_done_label_%d    ;if statment\n"
					"%s"
					"   if_done_label_%d:   ;more IF!\n",$3,Labeler,$5,Labeler);
				Labeler++;
				$$=Out;
				free($3);
				free($5);
				}

	| IF '(' exp ')' statmnt ELSE statmnt
				{
				char *Out;
				Out=malloc(strlen($3)+strlen($5)+1000+strlen($7));
				sprintf(Out,
					"%s"
					"    cmp.l    #0,d0                ;IFELSE statment\n"
					"    beq    ifelse_else_label_%d   ;IFELSE statment\n"
					"%s"
					"    bra    ifelse_done_label_%d   ;IFELSE statment\n"
					"   ifelse_else_label_%d:          ;else part of IFELSE Statement!\n"
					"%s"
					"   ifelse_done_label_%d:          ;End IFELSE Statement",
					$3,Labeler,$5,Labeler,Labeler,$7,Labeler);
				Labeler++;
				$$=Out;
				free($3);
				free($5);
				free($7);
				}

	   | FOR '(' opt_expr ';' opt_expr ';' opt_expr ')' statmnt
				{
				char *Out=malloc(strlen($3)+strlen($5)+strlen($7)+strlen($9)+1000);
				sprintf(Out,
					";*** 'for' loop!\n"
					"%s"
					"   for_loop_start_%d:\n"
					"%s"
					"    cmp.l      #0,d0\n"
					"    beq    for_loop_done_%d\n"
					"%s"
					"%s"
					"    bra    for_loop_start_%d\n"
					"   for_loop_done_%d:\n",
					$3,Labeler,$5,Labeler,$9,$7,Labeler,Labeler);
				Labeler++;
				$$=Out;
				free($3);
				free($5);
				free($7);
				free($9);
				}
	   | WHILE '(' opt_expr ')' statmnt
				{
				char *Out=malloc(strlen($3)+strlen($5)+1000);
				sprintf(Out,
					";*** 'while' loop!\n"
					"   while_loop_start_%d:\n"
					"%s"
					"    cmp.l      #0,d0\n"
					"    beq    while_loop_done_%d\n"
					"%s"
					"    bra    while_loop_start_%d\n"
					"   while_loop_done_%d:\n",
					Labeler,$3,Labeler,$5,Labeler,Labeler);
				Labeler++;
				$$=Out;
				free($3);
				free($5);
				}
	| block     {$$=$1;}
	;
%%
