DIGIT   [0-9]
ALPHA   [A-Za-z]

%%
[/][*][^(*/)]*[*][/]   {
//[/][*][^*]*[*][/]
		   //
//    fprintf(stderr,"Comment debugger, comment is:\n &&&%s&&&",yytext);
		}

[/][/].*$       {
                }

return      {return(RETURN);}
getch       {return(GETCH);}
putch       {return(PUTCH);}
clrscr      {return(CLRSCR);}
int     {return(INT);}
long        {return(INT);}
char        {return(CHAR);}
byte        {return(CHAR);}
short       {return(SHORT);}
for     {return(FOR);}
if      {return(IF);}
else        {return(ELSE);}
while       {return(WHILE);}
setfont     {return(SETFONT);}
proc        {return(PROC);}
random      {return(RANDOM);}
kbhit       {return(KBHIT);}
pxl_on      {return(PXL_ON);}
pxl_off     {return(PXL_OFF);}
pxl_chg     {return(PXL_CHG);}
true        {return(TRUE);}
false       {return(FALSE);}
delay       {return(DELAY);}
malloc      {return(MALLOC);}
free        {return(FREE);}
string      {return(STRING);}
puts        {return(PUTS);}
setprogname {return(SETPROGNAME);}


~.*$            {
		yylval.exp_string=CopyString(yytext);
                return(INLINE_ASSEMBLY);
                }

\"[^\"]*\"      {
		yylval.exp_string=CopyString(yytext);
                return(STRING_CONSTANT);
                }

[0-9]+      {
//      printf("lex found DEC_CONST is %s\n",yytext);
		yylval.exp_string=CopyString(yytext);
		return(DEC_CONST);
		}

'.'             {
				yylval.exp_string=CopyString(yytext);
				return(LITERAL_CHAR);
				}

([A-Z]|[a-z])([A-Z]|[a-z]|[0-9]|_)*   {
//      printf("Lex found an alpha sequence: %s (on line %d)\n",yytext,Lines);
		yylval.exp_string=CopyString(yytext);
			return(ESTRING);
		}

>=      {return(GREATER_THAN_OR_EQUAL_TO);}
\<=     {return(LESS_THAN_OR_EQUAL_TO);}
==      {return(EQUAL_TO);}
!=      {return(NOT_EQUAL_TO);}
\+      {return(ADD);}
\/      {return(DIVIDE);}
-       {return(SUBTRACT);}
\*      {return(MULTIPLY);}
%       {return(MODULO);}
(\|\|)  {return(LOGICAL_OR);}
\^\^    {return(LOGICAL_XOR);}
\<\<    {return(BITWISE_SHIFT_LEFT);}
>>      {return(BITWISE_SHIFT_RIGHT);}
&&      {return(LOGICAL_AND);}
\|      {return(BITWISE_OR);}
\<      {return(LESS_THAN);}
>       {return(GREATER_THAN);}
&       {return(BITWISE_AND);}
\^      {return(BITWISE_XOR);}

[ \t\b\r\f]+    {
//      printf("Lex found white space: %x\n",yytext[0]);
		}   /* eat up whitespace */
\n      {Lines++;}

.       {
//      printf( "Lex Found a teminal char: %s %x (on line %d)\n", yytext ,yytext[0],Lines);
		return(yytext[0]);
		}

%%
